# Features & roadmap
* Matrix → Discord
  * [ ] Message content
    * [ ] Plain text
    * [ ] Formatted messages
    * [ ] Media/files
    * [ ] Replies
    * [ ] Threads
    * [ ] Custom emojis
  * [ ] Message redactions
  * [ ] Reactions
    * [ ] Unicode emojis
    * [ ] Custom emojis (re-reacting with custom emojis sent from Discord already works)
  * [ ] Executing Discord bot commands
    * [ ] Basic arguments and subcommands
    * [ ] Subcommand groups
    * [ ] Mention arguments
    * [ ] Attachment arguments
  * [ ] Presence
  * [ ] Typing notifications
  * [ ] Own read status
  * [ ] Power level
  * [ ] Membership actions
    * [ ] Invite
    * [ ] Leave
    * [ ] Kick
  * [ ] Room metadata changes
    * [ ] Name
    * [ ] Avatar
    * [ ] Topic
  * [ ] Initial room metadata
* Discord → Matrix
  * [ ] Message content
    * [ ] Plain text
    * [ ] Formatted messages
    * [ ] Media/files
    * [ ] Replies
    * [ ] Threads
      * [ ] Auto-joining threads when opening
      * [ ] Backfilling threads after joining
    * [ ] Custom emojis
    * [ ] Embeds
    * [ ] Interactive components
    * [ ] Interactions (commands)
    * [ ] @everyone/@here mentions into @room
  * [ ] Message deletions
  * [ ] Reactions
    * [ ] Unicode emojis
    * [ ] Custom emojis ([MSC4027](https://github.com/matrix-org/matrix-spec-proposals/pull/4027))
  * [ ] Avatars
  * [ ] Presence
  * [ ] Typing notifications (currently partial support: DMs work after you type in them)
  * [ ] Own read status
  * [ ] Role permissions
  * [ ] Membership actions
    * [ ] Invite
    * [ ] Join
    * [ ] Leave
    * [ ] Kick
  * [ ] Channel/group DM metadata changes
    * [ ] Title
    * [ ] Avatar
    * [ ] Description
  * [ ] Initial channel/group DM metadata
  * [ ] User metadata changes
    * [ ] Display name
    * [ ] Avatar
  * [ ] Initial user metadata
    * [ ] Display name
    * [ ] Avatar
* Misc
  * [ ] Login methods
    * [ ] QR scan from mobile
    * [ ] Username/password
    * [ ] Manually providing access token
  * [ ] Automatic portal creation
    * [ ] After login
    * [ ] When receiving DM
  * [ ] Private chat creation by inviting Matrix puppet of Discord user to new room
  * [ ] Option to use own Matrix account for messages sent from other Discord clients
